// created on 2/20/2006 at 11:33 AM
namespace LessonPlan
{
using System;
using System.Data;
using Gtk;
using Glade;

public class FormClasses
{
		internal Gtk.TreeView tv;

		internal Gtk.ToolButton BtnAdd;
		internal Gtk.ToolButton BtnEdit;
		internal Gtk.ToolButton BtnDelete;
       
		int myRowStore = 1;
		LessonData.ClassPlansDataTable myClassesTable;

		public FormClasses(LessonData.ClassPlansDataTable ClassesTable) : base()
		{
			this.Icon =  this.RenderIcon("LP", Gtk.IconSize.Dialog, "LP");
			this.Title = "Classes";
				this.myClassesTable = ClassesTable;
				Gtk.Label myLabel = new Gtk.Label("Class List");
				myLabel.Xpad = 7;
				myLabel.Xalign = 0; 
				myLabel.WidthRequest = 150;
				Modules.SetLabelSize(myLabel, "x-large");
			
				////Toolbar and Display
				//Create Temporary Tools
				Gtk.Toolbar myToolbar = new Gtk.Toolbar();
				Gtk.ToolItem LabelTool = new Gtk.ToolItem();
				LabelTool.Add(myLabel);

				//Set Tool Tips
				Gtk.Tooltips myTooltips = new Gtk.Tooltips();
				LabelTool.SetTooltip(myTooltips, Title, "");  
				this.BtnAdd.SetTooltip(myTooltips, "Add Class", "");  
				this.BtnEdit.SetTooltip(myTooltips, "Edit Class", "");  
				this.BtnDelete.SetTooltip(myTooltips, "Delete Class", "");  
				//Add Buttons
				myToolbar.ModifyBg(Gtk.StateType.Normal, new Gdk.Color(System.Drawing.Color.PaleGoldenrod.R, System.Drawing.Color.PaleGoldenrod.G, System.Drawing.Color.PaleGoldenrod.B));   			
				myToolbar.Add(LabelTool);
				myToolbar.Add(this.BtnAdd);
				myToolbar.Add(this.BtnEdit);
				myToolbar.Add(this.BtnDelete);
		    
				myToolbar.ToolbarStyle = Gtk.ToolbarStyle.Icons;
				myToolbar.Tooltips = true;      	


				Gtk.HBox MainBox = new Gtk.HBox();
			
				//ListSide	(left most)
				Gtk.VBox ListBox = new Gtk.VBox();
				Gtk.ScrolledWindow ScrWin = new Gtk.ScrolledWindow();
				ScrWin.Add(this.tv);
				ListBox.Add(myToolbar);
				ListBox.Add(ScrWin);
				ListBox.SetChildPacking(myToolbar, false, false, Convert.ToUInt32(0), PackType.Start);

				MainBox.Add(ListBox);
				this.VBox.Add(MainBox);
				this.tv.Reorderable = true;
				this.tv.ButtonReleaseEvent += new ButtonReleaseEventHandler (OnTreeViewButtonPressEvent);
				this.tv.PopupMenu += new PopupMenuHandler (PopupMenuCb);
			
				//this.Response += new Gtk.ResponseHandler(DialogResp);  
				this.BtnAdd.Clicked += new System.EventHandler(AddClicked);
				this.BtnEdit.Clicked += new System.EventHandler(EditClicked);
				this.BtnDelete.Clicked += new System.EventHandler(DeleteClicked);
			
			
				SetupList();

				for (int n = 0; n <	 ClassesTable.Count; n++)
				{
					AddRow(ClassesTable[n]);
				}

				this.WidthRequest = 300; 
				this.HeightRequest = 250;

				this.AddButton("Close", Gtk.ResponseType.Ok);   
			
				this.tv.RowActivated += new Gtk.RowActivatedHandler (RowClicked);
				this.tv.Selection.Changed += new System.EventHandler (SelectionChanged);
			
				this.WindowPosition = Gtk.WindowPosition.Mouse;
            
				this.ShowAll();
			}
			private void SetupList()
			{
				System.Type[] myTypes = new System.Type[4];
				myTypes[0] = typeof(Gdk.Pixbuf);
				myTypes[1] = typeof(System.Data.DataRow);
				myRowStore = 1;
				myTypes[2] = typeof(bool);    //Editable
				myTypes[3] = typeof(string);  //String
				//Refresh store and tree
				Gtk.ListStore myStore = (Gtk.ListStore)this.tv.Model;
				if (!(myStore == null))
				{myStore.Clear();}
				myStore = new Gtk.ListStore(myTypes);
				this.tv.Model = myStore;
				this.tv.Selection.Mode = Gtk.SelectionMode.Multiple;  
				this.tv.HeadersVisible = false;

				//DeActivate Edit Button
				this.BtnEdit.State = Gtk.StateType.Insensitive; 
				this.BtnDelete.State = Gtk.StateType.Insensitive; 

				//Delete Old Columns
				while (this.tv.Columns.Length > 0)
				{
					this.tv.Columns[0].Destroy();
					this.tv.RemoveColumn(this.tv.Columns[0]);
				}

				//Add DataRow column
				this.tv.AppendColumn(Modules.MakeCol("Classes", 0, 2, 3, new Gtk.EditedHandler(CellEdited)));
			}
		private void CellEdited(object sender, Gtk.EditedArgs e)
		{
			Gtk.TreeIter iter; 
							
			if (Modules.GetFirstSelectedIter(this.tv, out iter))
			{
				Gtk.ListStore myStore = (Gtk.ListStore)this.tv.Model;
				myStore.SetValue(iter, 3, e.NewText);
				LessonData.ClassPlansRow myRow = (LessonData.ClassPlansRow)myStore.GetValue(iter, 1);   //myRowStore=1
				myRow.ClassNames = e.NewText;
			}
		}

			private Gtk.TreeIter AddRow(LessonData.ClassPlansRow myRow)
			{
				Gtk.ListStore myStore = (Gtk.ListStore)this.tv.Model;
				Gtk.TreeIter iter; 
				iter = myStore.Append();
				myStore.SetValue(iter, 1, myRow);
				myStore.SetValue(iter, 2, true);
				myStore.SetValue(iter, 3, myRow.ClassNames);
                
				Gdk.Pixbuf newpic =  this.RenderIcon("Apple", Gtk.IconSize.Menu, "LP");
				myStore.SetValue(iter, 0, newpic);

				return iter;
			}
			private void AddClicked(object sender, System.EventArgs e)
			{
				LessonData.ClassPlansRow newRow = this.myClassesTable.NewClassPlansRow();
				newRow.ClassNames = "New Class";
				this.myClassesTable.Rows.Add(newRow);
				Gtk.TreeIter newIter = AddRow(newRow);

				Gtk.ListStore myStore = (Gtk.ListStore)this.tv.Model;
				CellRendererText Render = (CellRendererText)this.tv.Columns[0].CellRenderers[1];
				this.tv.SetCursorOnCell(myStore.GetPath(newIter), this.tv.Columns[0], Render, true); 
			}
	
			private void EditClicked(object sender, System.EventArgs e)
			{
				Gtk.ListStore myStore = (Gtk.ListStore)this.tv.Model;
				Gtk.TreeIter iter; 
				if (Modules.GetFirstSelectedIter(this.tv, out iter))
				{
					CellRendererText Render = (CellRendererText)this.tv.Columns[0].CellRenderers[1];
					this.tv.SetCursorOnCell(myStore.GetPath(iter), this.tv.Columns[0], Render, true); 
				}	
			}
		private void DeleteClicked(object sender, System.EventArgs e)
		{
			Gtk.ListStore myStore = (Gtk.ListStore)this.tv.Model;
			Gtk.TreeIter iter; 
			if (Modules.GetFirstSelectedIter(this.tv, out iter))
			{
			LessonData.ClassPlansRow myRow = (LessonData.ClassPlansRow)myStore.GetValue(iter, myRowStore);
			
			Gtk.Dialog DeleteDialog = new Gtk.Dialog();
			DeleteDialog.Title = "Delete Class";
			DeleteDialog.Icon = this.Icon;
			Gtk.Label Warning = new Gtk.Label("This will delete the class named " + myRow.ClassNames + " and all of its class plans.");
				Gtk.Label Question = new Gtk.Label("Are you sure you want to delete " + myRow.ClassNames + "?");
					Warning.SetPadding(5, 2);
			Question.SetPadding(5, 2);
			DeleteDialog.VBox.Add(Warning);
			DeleteDialog.VBox.Add(Question);
			DeleteDialog.TypeHint = Gdk.WindowTypeHint.Menu; 
			DeleteDialog.SetPosition(Gtk.WindowPosition.Mouse); 
			DeleteDialog.AddButton("No", Gtk.ResponseType.No);
			DeleteDialog.AddButton("Yes", Gtk.ResponseType.Yes);
			DeleteDialog.Response += new Gtk.ResponseHandler(DeleteResponse); 
			DeleteDialog.ShowAll();
			DeleteDialog.Run();
			}		
		}
		private void DeleteResponse(object sender, Gtk.ResponseArgs e)
		{
			Gtk.Dialog DeleteDialog = (Gtk.Dialog) sender;
			if (e.ResponseId == Gtk.ResponseType.Yes)
			{
				try
				{
					Gtk.ListStore myStore = (Gtk.ListStore)this.tv.Model;
					Gtk.TreeIter iter; 
					if (Modules.GetFirstSelectedIter(this.tv, out iter))
					{
					LessonData.ClassPlansRow myRow = (LessonData.ClassPlansRow)myStore.GetValue(iter, myRowStore);

					Gtk.Label Warning = (Gtk.Label) DeleteDialog.VBox.Children[0];
					Gtk.Label Progress = (Gtk.Label) DeleteDialog.VBox.Children[1];
					Warning.Text = "Deleting....";
					Progress.Text = "";
					LessonData myLessons = (LessonData) this.myClassesTable.DataSet;
					LessonData.PlansRow[] rowChildren = (LessonData.PlansRow[]) myRow.GetChildRows(this.myClassesTable.ChildRelations[this.myClassesTable.TableName + "_" + myLessons.Plans.TableName]); 
					for(int n=0; n<rowChildren.Length; n++)
					{
						Warning.Text = "Deleting...." + Convert.ToString((int)(((float)n/(float)rowChildren.Length)*100)) + "% Complete";
						Progress.Text = "Deleting Plan for " + rowChildren[n].PlanDate; 
						rowChildren[n].Delete();
						Modules.DoEvents();
					}
					Progress.Text = ""; 
					Warning.Text = "Deleting...." + myRow.ClassNames;
					myRow.Delete();
					myStore.Remove(ref iter);
					Warning.Text = "Complete";
					}
				}
				catch(Exception ex)
				{
					Console.WriteLine(ex.Message);
				}
			}
			DeleteDialog.Destroy();
		}

			private void RowClicked (object o, Gtk.RowActivatedArgs args)
			{
				//Activated when a row is changed
				Gtk.TreeIter iter; 
					if (Modules.GetFirstSelectedIter(this.tv, out iter))
				{
					//mySelection.GetSelected(out Model, out iter);
					//Gtk.ListStore myStore = (Gtk.ListStore)this.tv.Model;
					//LessonData.ClassPlansRow myRow = (LessonData.ClassPlansRow)myStore.GetValue(iter, myRowStore);
					this.BtnEdit.Sensitive = true;
					this.BtnDelete.Sensitive = true;
				}

			}

			private void SelectionChanged (object o, System.EventArgs args)
			{
				//Activated when a row is changed
					Gtk.TreeIter iter; 
					if (Modules.GetFirstSelectedIter(this.tv, out iter))
				{
					//mySelection.GetSelected(out Model, out iter);
					//Gtk.ListStore myStore = (Gtk.ListStore)this.tv.Model;
					//LessonData.ClassPlansRow myRow = (LessonData.ClassPlansRow)myStore.GetValue(iter, myRowStore);
						this.BtnEdit.Sensitive = true;
						this.BtnDelete.Sensitive = true;
				}
			}
		
		#region "PopupMenu"
			internal Gtk.ImageMenuItem MenuItemAdd;
			void NewPopupMenu (Gdk.EventButton ev)
			{
				Console.WriteLine ("Popup Menu!");
			
				Gtk.Menu menu = new Menu ();
				AccelGroup group = new AccelGroup ();
				ImageMenuItem item;
				MenuItemAdd = new Gtk.ImageMenuItem (Stock.Add, group);	
				MenuItemAdd.Activated += new System.EventHandler(AddClicked);
				menu.Append (MenuItemAdd);
				
				//Can be pressed if there is a row selected
					Gtk.TreeIter iter; 
					if (Modules.GetFirstSelectedIter(this.tv, out iter))
				{
					item = new ImageMenuItem ("Edit");
					item.Image = new Gtk.Image(Gtk.Stock.Convert, Gtk.IconSize.SmallToolbar);
					item.Activated += new System.EventHandler(EditClicked);
					menu.Append (item);			
					item = new ImageMenuItem (Stock.Delete, group);
					item.Activated += new System.EventHandler(DeleteClicked);
					menu.Append (item);			
				}

				menu.ShowAll ();
				menu.Popup (null, null, null, IntPtr.Zero,
					(ev != null) ? ev.Button : 0, (ev != null) ? ev.Time : 0);
				menu = null;
			}

		
			//[GLib.ConnectBefore]	 
			private void OnTreeViewButtonPressEvent (object o, ButtonReleaseEventArgs args)
			{			
				Console.WriteLine ("Pressed button {0}", args.Event.Button);
			
				switch (args.Event.Button)
				{
					case 3:
						NewPopupMenu (args.Event);
						break;
				}		
			}

			void PopupMenuCb (object o, PopupMenuArgs args)
			{
				Console.WriteLine ("Popup Menu Called!");
				NewPopupMenu (null);
			}

		#endregion

		}
	}
