using System;
using System.Data;
using Gtk;

namespace LessonPlan
{
	/// <summary>
	/// Summary description for RatingChoice.
	/// </summary>
	public class StarChoice  : Gtk.ToolItem
	{
		public DataRow myRow;
		//Name of Widget is the Column Name

		
		internal StarBtn StarBtn1;
		internal StarBtn StarBtn2;
		internal StarBtn StarBtn3;
		internal StarBtn StarBtn4;
		internal StarBtn StarBtn5;
		internal StarBtn[] StarBtns;

		internal System.EventHandler StarActivated;
		internal Gtk.EnterNotifyEventHandler StarEntered;
		internal Gtk.LeaveNotifyEventHandler StarLeft;

		public StarChoice() : base()
		{
			StarBtn1 = new StarBtn();
			StarBtn1.Name = "1";
			//StarBtn1.ModifyBg(Gtk.StateType.Normal, BackgrdColor);   			
			StarBtn2 = new StarBtn();
			StarBtn2.Name = "2";
			//StarBtn2.ModifyBg(Gtk.StateType.Normal, BackgrdColor);   			
			StarBtn3 = new StarBtn();
			StarBtn3.Name = "3";
			//StarBtn3.ModifyBg(Gtk.StateType.Normal, BackgrdColor);   			
			StarBtn4 = new StarBtn();
			StarBtn4.Name = "4";
			//StarBtn4.ModifyBg(Gtk.StateType.Normal, BackgrdColor);   			
			StarBtn5 = new StarBtn();
			StarBtn5.Name = "5";
			//StarBtn5.ModifyBg(Gtk.StateType.Normal, BackgrdColor);   			

			StarBtns = new StarBtn[5]{StarBtn1, StarBtn2, StarBtn3, StarBtn4, StarBtn5};

			Gtk.HBox BtnBox = new Gtk.HBox();

			BtnBox.Add(StarBtn1);
			BtnBox.Add(StarBtn2);
			BtnBox.Add(StarBtn3);
			BtnBox.Add(StarBtn4);
			BtnBox.Add(StarBtn5);
			
			//Gtk.Label Ratinglb = new Gtk.Label("(5 is the highest rating)");
			//Ratinglb.Xpad = 4;
			//BtnBox.Add(Ratinglb);

			this.Add(BtnBox);

			LessonData.LessonsDataTable TempTable = new LessonData.LessonsDataTable();
			this.Name = TempTable.StarColumn.ColumnName;
			TempTable.Dispose();

			StarActivated = new System.EventHandler(OnButtonPress);
			StarBtn1.Clicked += StarActivated;
			StarBtn2.Clicked += StarActivated;
			StarBtn3.Clicked += StarActivated;
			StarBtn4.Clicked += StarActivated;
			StarBtn5.Clicked += StarActivated;

			StarEntered = new Gtk.EnterNotifyEventHandler(Entered);
			StarBtn1.EnterNotifyEvent += StarEntered;
			StarBtn2.EnterNotifyEvent += StarEntered;
			StarBtn3.EnterNotifyEvent += StarEntered;
			StarBtn4.EnterNotifyEvent += StarEntered;
			StarBtn5.EnterNotifyEvent += StarEntered;

			StarLeft = new Gtk.LeaveNotifyEventHandler(Left);
			StarBtn1.LeaveNotifyEvent += StarLeft;
			StarBtn2.LeaveNotifyEvent += StarLeft;
			StarBtn3.LeaveNotifyEvent += StarLeft;
			StarBtn4.LeaveNotifyEvent += StarLeft;
			StarBtn5.LeaveNotifyEvent += StarLeft;
		}

		public void SetValue(DataRow row)
		{
			this.myRow = row;
			if (!(this.myRow == null)&&!(this.myRow.RowState == System.Data.DataRowState.Detached)&& myRow.IsNull(this.Name) == false) 
			{
				AmtStars (Convert.ToInt32(myRow[this.Name]));	
			}
			else
			{
				AmtStars(0);
			}
		}

		private void AmtStars(int numStars)
		{
			for (int n=0; n<5; n++)
			{
				if (n+1 <= numStars)
				StarBtns[n].setStar(1);
				else
				StarBtns[n].setStar(0);
			}
		}

		public void OnButtonPress(object sender, System.EventArgs args)
		{
			StarBtn1.Clicked -= StarActivated;
			StarBtn2.Clicked -= StarActivated;
			StarBtn3.Clicked -= StarActivated;
			StarBtn4.Clicked -= StarActivated;
			StarBtn5.Clicked -= StarActivated;

			StarBtn Btn = (StarBtn)sender;
			if (!(myRow == null))
			{
				myRow[this.Name] = Convert.ToInt32(Btn.Name);
				AmtStars(Convert.ToInt32(Btn.Name));
			}

			StarBtn1.Clicked += StarActivated;
			StarBtn2.Clicked += StarActivated;
			StarBtn3.Clicked += StarActivated;
			StarBtn4.Clicked += StarActivated;
			StarBtn5.Clicked += StarActivated;
		}
		private void Entered(object sender, Gtk.EnterNotifyEventArgs e)
		{
			 Selecting(sender);
		}
		private void Left(object sender, Gtk.LeaveNotifyEventArgs e)
		{
			StarBtn1.EnterNotifyEvent -= StarEntered;
			StarBtn2.EnterNotifyEvent -= StarEntered;
			StarBtn3.EnterNotifyEvent -= StarEntered;
			StarBtn4.EnterNotifyEvent -= StarEntered;
			StarBtn5.EnterNotifyEvent -= StarEntered;

			SetValue(this.myRow);

			StarBtn1.EnterNotifyEvent += StarEntered;
			StarBtn2.EnterNotifyEvent += StarEntered;
			StarBtn3.EnterNotifyEvent += StarEntered;
			StarBtn4.EnterNotifyEvent += StarEntered;
			StarBtn5.EnterNotifyEvent += StarEntered;
		}
		private void Selecting (object sender)
		{
			StarBtn Btn = (StarBtn)sender;
			int currentStar = Convert.ToInt32(Btn.Name);
			int SelectedStar = 0;
			if (!(this.myRow == null) && myRow.IsNull(this.Name) == false) 
			{
				SelectedStar = Convert.ToInt32(myRow[this.Name]);	
			}

			for (int n=0; n<5; n++)
			{
				if (n+1 <= SelectedStar && n+1 <= currentStar)	   //normal star
					StarBtns[n].setStar(1);
				else if (n+1 <= SelectedStar && n+1 > currentStar)	 //Shaded star
					StarBtns[n].setStar(2);
				else if (n+1 > currentStar)  //Gray Star
					StarBtns[n].setStar(0);
				else
					StarBtns[n].setStar(3);
			}
		}
	}

	public class StarBtn  : Gtk.Button   
	{
		public string Selected = "Star";
		public string UnSelected = "Spade";
		public string Highlighted = "GrayStar";
		public string OverSelected = "ShadedStar";

		public string HalfSelected = "Gavel";
		private float Value = 0; // 0 is none,  1 is selected, .5 is half selected, 2 is over selection, 3 is over current
		private Gtk.Image myImage = new Gtk.Image("Spade", Gtk.IconSize.SmallToolbar);

		public StarBtn() : base()
		{
			this.Add(myImage);
			this.Relief = Gtk.ReliefStyle.None;
			//can use this as an event box, but the background looks odd while using wimp
		}
		public void setStar(float newValue)
		{
			Value = newValue;
			if (Value == 0.5)
					myImage.Stock = HalfSelected;
			else if (Value == 1)
					myImage.Stock = Selected;
			else if (Value == 2)
					myImage.Stock = OverSelected;
			else if (Value == 3)
				myImage.Stock = Highlighted;
			else
					myImage.Stock = UnSelected;

		}

	}
}
