/*
 * icon.c
 * lessonplan
 *
 * by Doug Wolfe
 * doug@wolfescience.com 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc.,  59 Temple Place - Suite 330, Cambridge, MA 02139, USA.
 *
 */
 
#include <gtk/gtk.h>

#include "support.h"

static void
lp_icon_add_to_factory(GtkIconFactory * lp_icon_factory, const gchar *stock_id, gchar *pixbuf_filename)
{
	GtkIconSet * lp_icon_set = gtk_icon_set_new_from_pixbuf (create_pixbuf(pixbuf_filename));
	gtk_icon_factory_add (lp_icon_factory, stock_id, lp_icon_set);                   
}

void 
lp_icon_add_defaults()
{
	GtkIconFactory * lp_icon_factory = gtk_icon_factory_new();
	lp_icon_add_to_factory(lp_icon_factory, "lp", "BlueLP.ico");
	lp_icon_add_to_factory(lp_icon_factory, "apple", "apple1.tif");
	lp_icon_add_to_factory(lp_icon_factory, "methane", "methane.tif");	
	lp_icon_add_to_factory(lp_icon_factory, "gavel", "gavel.tif");
	lp_icon_add_to_factory(lp_icon_factory, "keyquestions", "keyquestions.tif");		
	lp_icon_add_to_factory(lp_icon_factory, "weeklyplan", "weeklyplan2.tif");
	lp_icon_add_to_factory(lp_icon_factory, "lessonplan", "lessonplan.tif");		
	lp_icon_add_to_factory(lp_icon_factory, "help", "help.png");
	gtk_icon_factory_add_default(lp_icon_factory);
}
