/*
 * lpoptions.c
 * lessonplan
 * This file is a backend for calling specified settings or preferences.
 *
 * by Doug Wolfe
 * doug@wolfescience.com 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc.,  59 Temple Place - Suite 330, Cambridge, MA 02139, USA.
 *
 */

#include <gtk/gtk.h>

static int
lp_options_get(const char * option_name, int default_value)
{
int value = default_value;
 gchar * sql_statement = g_strdup_printf("SELECT * FROM option WHERE option_name='%s'", option_name);
if(lp_sql_row_count(sql_statement))
{
     char * value_char = lp_sql_value(sql_statement, g_strdup("option_value"));
     value = atoi(value_char); // cast from a char to an int
}        
return value;                   
}

static void
lp_options_set(const char * option_name, int new_value)
{
if(new_value != -1)
{
  gchar * sql_statement = g_strdup_printf("SELECT * FROM option WHERE option_name='%s'", option_name);
  if(lp_sql_row_count(sql_statement))
  {
   sql_statement = g_strdup_printf("UPDATE option SET option_value='%d' WHERE option_name='%s'", new_value, option_name);  
  }
  else
  {
   sql_statement = g_strdup_printf("INSERT INTO option ('option_name', 'option_value') VALUES ('%s','%d')", option_name, new_value);        
  }   
  lp_sql_row_count(sql_statement);           
}
else
{
    printf("NULL VAlUE = -1 for %s\n", option_name);
}
}

int
lp_options_get_show_dates_left(int new_value)
{
lp_options_set("show_dates_left", new_value);
int value = lp_options_get("show_dates_left",0); //Default false
return value;
}

int
lp_options_show_month(int new_value)
{
lp_options_set("show_month", new_value);
int value = lp_options_get("show_month",0); //Default False
return value;
}

int
lp_options_get_weekday_first(int new_value)
{
/**Monday = 1 thru Sunday = 7,  G_DATE_BAD_WEEKDAY = 0**/
lp_options_set("weekday_first", new_value);
int value = lp_options_get("weekday_first",1); //Default Monday
return value;
}

int
lp_options_hide_monday(int new_value)
{
lp_options_set("hide_monday", new_value);
int value = lp_options_get("hide_monday",0); //Default False
return value;
}

int
lp_options_hide_tuesday(int new_value)
{
lp_options_set("hide_tuesday", new_value);
int value = lp_options_get("hide_tuesday",0); //Default False
return value;
}

int
lp_options_hide_wednesday(int new_value)
{
lp_options_set("hide_wednesday", new_value);
int value = lp_options_get("hide_wednesday",0); //Default False
return value;
}

int
lp_options_hide_thursday(int new_value)
{
lp_options_set("hide_thursday", new_value);
int value = lp_options_get("hide_thursday",0); //Default False
return value;
}

int
lp_options_hide_friday(int new_value)
{
lp_options_set("hide_friday", new_value);
int value = lp_options_get("hide_friday",0); //Default False
return value;
}

int
lp_options_hide_saturday(int new_value)
{
lp_options_set("hide_saturday", new_value);
int value = lp_options_get("hide_saturday",0); //Default False
return value;
}

int
lp_options_hide_sunday(int new_value)
{
lp_options_set("hide_sunday", new_value);
int value = lp_options_get("hide_sunday",0); //Default False
return value;
}

int
lp_options_show_weekly_plan(int new_value)
{
lp_options_set("show_weekly_plan", new_value);
int value = lp_options_get("show_weekly_plan",1); //Default TRUE
return value;
}

int
lp_options_show_weekly_at_start(int new_value)
{
lp_options_set("show_week_at_start", new_value);
int value = lp_options_get("show_week_at_start",0); //Default False
return value;
}
