/*
 * main.c
 * lessonplan
 *
 * by Doug Wolfe
 * doug@wolfescience.com 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc.,  59 Temple Place - Suite 330, Cambridge, MA 02139, USA.
 *
 */
 
/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "interface.h"
#include "support.h"
#include "callbacks.h"
#include "icon.h"
gchar *package_data_dir;

int
main (int argc, char *argv[])
{
GtkWidget *lp_window_main;

#ifdef G_OS_WIN32
  gchar *package_prefix = g_win32_get_package_installation_directory (NULL, NULL);
  package_data_dir = package_prefix;//g_build_filename (package_prefix, "share", NULL);
#else
 package_data_dir = g_build_filename (PACKAGE_DATA_DIR, PACKAGE, NULL);
#endif

#ifdef ENABLE_NLS
  bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
  bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
  textdomain (GETTEXT_PACKAGE);
#endif

  gtk_set_locale ();
  gtk_init (&argc, &argv);
  
  gchar *pixmap_dir;
  pixmap_dir = g_build_filename (package_data_dir, "pixmaps", NULL);
  printf("Pixmaps Directory:%s\n", pixmap_dir);
  add_pixmap_directory (pixmap_dir);
  
  pixmap_dir = g_build_filename (package_data_dir, "xhtmlite/pixmaps", NULL);
  printf("Pixmaps Directory:%s\n", pixmap_dir);
  add_pixmap_directory (pixmap_dir);
  g_free (pixmap_dir);
  lp_icon_add_defaults();

  lp_window_main = create_lp_window_main ();
  lp_callbacks_setup_window_main(lp_window_main);
  
  printf("Arguments passed:%s, %s\n", argv[0], argv[1]);
  if (argv[1] != NULL)
  {
    lp_open_database(argv[1], lp_window_main);
  }
  else
  {
	lp_new_database(lp_window_main);
  }
   gtk_widget_show (lp_window_main);

  gtk_main ();
  return 0;
}
